# pyright: reportUnusedImport=false
import struct
from typing import Optional, Self, Sequence
from .. import abcs
from ..core import Request, serialize_bytes_to
_bytes = bytes | bytearray | memoryview
def req_pq(*, nonce: int) -> Request[abcs.ResPq]:
    _buffer = bytearray(b'x\x97F`')
    _buffer += nonce.to_bytes(16)
    return Request(b'' + _buffer)
def req_pq_multi(*, nonce: int) -> Request[abcs.ResPq]:
    _buffer = bytearray(b'\xf1\x8e~\xbe')
    _buffer += nonce.to_bytes(16)
    return Request(b'' + _buffer)
def req_dh_params(*, nonce: int, server_nonce: int, p: _bytes, q: _bytes, public_key_fingerprint: int, encrypted_data: _bytes) -> Request[abcs.ServerDhParams]:
    _buffer = bytearray(b'\xbe\xe4\x12\xd7')
    _buffer += nonce.to_bytes(16)
    _buffer += server_nonce.to_bytes(16)
    serialize_bytes_to(_buffer, p)
    serialize_bytes_to(_buffer, q)
    _buffer += struct.pack('<q', public_key_fingerprint)
    serialize_bytes_to(_buffer, encrypted_data)
    return Request(b'' + _buffer)
def set_client_dh_params(*, nonce: int, server_nonce: int, encrypted_data: _bytes) -> Request[abcs.SetClientDhParamsAnswer]:
    _buffer = bytearray(b'\x1f_\x04\xf5')
    _buffer += nonce.to_bytes(16)
    _buffer += server_nonce.to_bytes(16)
    serialize_bytes_to(_buffer, encrypted_data)
    return Request(b'' + _buffer)
def destroy_auth_key() -> Request[abcs.DestroyAuthKeyRes]:
    _buffer = bytearray(b'`QC\xd1')
    return Request(b'' + _buffer)
def rpc_drop_answer(*, req_msg_id: int) -> Request[abcs.RpcDropAnswer]:
    _buffer = bytearray(b'@\xa7\xe4X')
    _buffer += struct.pack('<q', req_msg_id)
    return Request(b'' + _buffer)
def get_future_salts(*, num: int) -> Request[abcs.FutureSalts]:
    _buffer = bytearray(b'\x04\xbd!\xb9')
    _buffer += struct.pack('<i', num)
    return Request(b'' + _buffer)
def ping(*, ping_id: int) -> Request[abcs.Pong]:
    _buffer = bytearray(b'\xecw\xbez')
    _buffer += struct.pack('<q', ping_id)
    return Request(b'' + _buffer)
def ping_delay_disconnect(*, ping_id: int, disconnect_delay: int) -> Request[abcs.Pong]:
    _buffer = bytearray(b'\x8c{B\xf3')
    _buffer += struct.pack('<qi', ping_id, disconnect_delay)
    return Request(b'' + _buffer)
def destroy_session(*, session_id: int) -> Request[abcs.DestroySessionRes]:
    _buffer = bytearray(b'&!Q\xe7')
    _buffer += struct.pack('<q', session_id)
    return Request(b'' + _buffer)
